org.eclipse.viatra.addon.querybasedfeatures.runtime

## Class InvertableQueryBasedEList<ComputedType,StorageType>

- java.lang.Object
- - java.util.AbstractCollection<E>
  - - java.util.AbstractList<E>
    - - org.eclipse.emf.common.util.AbstractEList<ComputedType>
      - - org.eclipse.viatra.addon.querybasedfeatures.runtime.InvertableQueryBasedEList<ComputedType,StorageType>

- All Implemented Interfaces:
    java.lang.Iterable<ComputedType>, java.util.Collection<ComputedType>, java.util.List<ComputedType>, org.eclipse.emf.common.util.EList<ComputedType>

      public class InvertableQueryBasedEList<ComputedType,StorageType>
      extends org.eclipse.emf.common.util.AbstractEList<ComputedType>

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.eclipse.emf.common.util.AbstractEList

      `org.eclipse.emf.common.util.AbstractEList.BasicIndexOutOfBoundsException, org.eclipse.emf.common.util.AbstractEList.EIterator<E1>, org.eclipse.emf.common.util.AbstractEList.EListIterator<E1>, org.eclipse.emf.common.util.AbstractEList.NonResolvingEIterator<E1>, org.eclipse.emf.common.util.AbstractEList.NonResolvingEListIterator<E1>`

  - ### Field Summary

    - ### Fields inherited from class java.util.AbstractList

      `modCount`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `InvertableQueryBasedEList(org.eclipse.emf.ecore.EObject sourceObject, org.eclipse.emf.common.util.EList<StorageType> storageEList, IQueryBasedFeatureHandler handler, QueryBasedFeatureInverter<ComputedType,StorageType> inverter)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `addAllUnique(java.util.Collection<? extends ComputedType> collection)`
    `boolean` | `addAllUnique(int index, java.util.Collection<? extends ComputedType> collection)`
    `boolean` | `addAllUnique(int index, java.lang.Object[] objects, int start, int end)`
    `boolean` | `addAllUnique(java.lang.Object[] objects, int start, int end)`
    `void` | `addUnique(ComputedType object)`
    `void` | `addUnique(int index, ComputedType object)`
    `protected java.util.List<ComputedType>` | `basicList()`
    `ComputedType` | `get(int index)`
    `ComputedType` | `move(int targetIndex, int sourceIndex)`
    `protected ComputedType` | `primitiveGet(int index)`
    `ComputedType` | `remove(int index)`
    `ComputedType` | `setUnique(int index, ComputedType object)`
    `int` | `size()`
    `protected ComputedType` | `validate(int index, ComputedType object)`

    - ### Methods inherited from class org.eclipse.emf.common.util.AbstractEList

      `add, add, addAll, addAll, basicGet, basicIterator, basicListIterator, basicListIterator, canContainNull, didAdd, didChange, didClear, didMove, didRemove, didSet, equalObjects, equals, getDuplicates, getNonDuplicates, hashCode, isUnique, iterator, listIterator, listIterator, move, remove, removeAll, resolve, retainAll, set, toString, useEquals`

    - ### Methods inherited from class java.util.AbstractList

      `clear, indexOf, lastIndexOf, removeRange, subList`

    - ### Methods inherited from class java.util.AbstractCollection

      `contains, containsAll, isEmpty, toArray, toArray`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.util.List

      `clear, contains, containsAll, indexOf, isEmpty, lastIndexOf, replaceAll, sort, spliterator, subList, toArray, toArray`

    - ### Methods inherited from interface java.util.Collection

      `parallelStream, removeIf, stream`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach`

- - ### Constructor Detail

    - #### InvertableQueryBasedEList

          public InvertableQueryBasedEList(org.eclipse.emf.ecore.EObject sourceObject,
                                           org.eclipse.emf.common.util.EList<StorageType> storageEList,
                                           IQueryBasedFeatureHandler handler,
                                           QueryBasedFeatureInverter<ComputedType,StorageType> inverter)

  - ### Method Detail

    - #### validate

          protected ComputedType validate(int index,
                                          ComputedType object)

      Overrides:
        `validate` in class `org.eclipse.emf.common.util.AbstractEList<ComputedType>`

    - #### primitiveGet

          protected ComputedType primitiveGet(int index)

      Specified by:
        `primitiveGet` in class `org.eclipse.emf.common.util.AbstractEList<ComputedType>`

    - #### setUnique

          public ComputedType setUnique(int index,
                                        ComputedType object)

      Specified by:
        `setUnique` in class `org.eclipse.emf.common.util.AbstractEList<ComputedType>`

    - #### addUnique

          public void addUnique(ComputedType object)

      Specified by:
        `addUnique` in class `org.eclipse.emf.common.util.AbstractEList<ComputedType>`

    - #### addUnique

          public void addUnique(int index,
                                ComputedType object)

      Specified by:
        `addUnique` in class `org.eclipse.emf.common.util.AbstractEList<ComputedType>`

    - #### addAllUnique

          public boolean addAllUnique(java.util.Collection<? extends ComputedType> collection)

      Specified by:
        `addAllUnique` in class `org.eclipse.emf.common.util.AbstractEList<ComputedType>`

    - #### addAllUnique

          public boolean addAllUnique(int index,
                                      java.util.Collection<? extends ComputedType> collection)

      Specified by:
        `addAllUnique` in class `org.eclipse.emf.common.util.AbstractEList<ComputedType>`

    - #### addAllUnique

          public boolean addAllUnique(java.lang.Object[] objects,
                                      int start,
                                      int end)

      Specified by:
        `addAllUnique` in class `org.eclipse.emf.common.util.AbstractEList<ComputedType>`

    - #### addAllUnique

          public boolean addAllUnique(int index,
                                      java.lang.Object[] objects,
                                      int start,
                                      int end)

      Specified by:
        `addAllUnique` in class `org.eclipse.emf.common.util.AbstractEList<ComputedType>`

    - #### remove

          public ComputedType remove(int index)

      Specified by:
        `remove` in interface `java.util.List<ComputedType>`
      Specified by:
        `remove` in class `org.eclipse.emf.common.util.AbstractEList<ComputedType>`

    - #### move

          public ComputedType move(int targetIndex,
                                   int sourceIndex)

      Specified by:
        `move` in interface `org.eclipse.emf.common.util.EList<ComputedType>`
      Specified by:
        `move` in class `org.eclipse.emf.common.util.AbstractEList<ComputedType>`

    - #### basicList

          protected java.util.List<ComputedType> basicList()

      Specified by:
        `basicList` in class `org.eclipse.emf.common.util.AbstractEList<ComputedType>`

    - #### get

          public ComputedType get(int index)

      Specified by:
        `get` in interface `java.util.List<ComputedType>`
      Specified by:
        `get` in class `java.util.AbstractList<ComputedType>`

    - #### size

          public int size()

      Specified by:
        `size` in interface `java.util.Collection<ComputedType>`
      Specified by:
        `size` in interface `java.util.List<ComputedType>`
      Specified by:
        `size` in class `java.util.AbstractCollection<ComputedType>`